---
source_url: https://www.pubnub.com/docs/sdks/rest-api/get-actions
title: Get actions
---

# Get actions

> For AI agents: documentation index at https://www.pubnub.com/llms-full.txt

Pagination can be controlled using `start`, `end` and `limit` parameters, where `start` > `end`. If `start` is not provided, the server uses the current time. Providing no `end` or `limit` means there is no limit to the number of actions being requested. In this event the server will try and retrieve all actions for the channel, going back in time forever. In some cases, due to internal limitations on the number of queries performed per request, the server will not be able to give the full range of actions requested. In these cases a `more` link will be provided. This is a signal that internal limiting has occurred, and the `more` link itself can be used to continue fetching the originally requested range of actions.

| Path Parameters |
| --- |
| `sub_key`string—**REQUIRED**Your app's subscribe key from Admin Portal.Example: sub-c-50264475-1902-558x-d213-7p19052012n2 |
| `channel`string—**REQUIRED**The channel ID to perform the operation on.Example: myChannel |

| Query Parameters |
| --- |
| `start`stringAction timetoken denoting the start of the range requested. Returned values will be less than start.Example: 12332312312312312 |
| `end`stringAction timetoken denoting the end of the range requested. Returned values will be greater than or equal to end.Example: 12332312312312312 |
| `limit`integerNumber of actions to return in response.Example: 500 |
| `auth`stringString which is either the auth key (Access Manager legacy) or a valid token (Access Manager) used to authorize the operation if access control is enabled.Example: myAuth / p0thisAkFl043rhDdHRsCkNyZXisRGNoYW6hanNlY3JldAFDZ3Jwsample3KgQ3NwY6BDcGF0pERjaGFuoENnctokenVzcqBDc3BjoERtZXRhoENzaWdYIGOAeTyWGJI |
| `signature`stringSignature used to verify that the request was signed with the secret key associated with the subscribe key.If Access Manager is enabled, either a valid authorization token or a signature are required.Check Access Manager documentation for details on how to compute the signature. |
| `timestamp`integerUnix epoch timestamp used as a nonce for signature computation. Must have no more than ± 60 seconds offset from NTP.Required if the signature parameter is supplied. |

| Responses |
| --- |
| `200`The actions were fetched.Schema — OPTIONALstatus integer — OPTIONALdata object[] — OPTIONALtype string — OPTIONALvalue string — OPTIONALactionTimetoken string — OPTIONALmessageTimetoken string — OPTIONALuuid string — OPTIONALmore object — OPTIONALurl string — OPTIONALstart string — OPTIONALend string — OPTIONALlimit string — OPTIONAL | Schema—**OPTIONAL** | `status`integer—**OPTIONAL** | `data`object[]—**OPTIONAL**type string — OPTIONALvalue string — OPTIONALactionTimetoken string — OPTIONALmessageTimetoken string — OPTIONALuuid string — OPTIONAL | `type`string—**OPTIONAL** | `value`string—**OPTIONAL** | `actionTimetoken`string—**OPTIONAL** | `messageTimetoken`string—**OPTIONAL** | `uuid`string—**OPTIONAL** | `more`object—**OPTIONAL**url string — OPTIONALstart string — OPTIONALend string — OPTIONALlimit string — OPTIONAL | `url`string—**OPTIONAL** | `start`string—**OPTIONAL** | `end`string—**OPTIONAL** | `limit`string—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `data`object[]—**OPTIONAL**type string — OPTIONALvalue string — OPTIONALactionTimetoken string — OPTIONALmessageTimetoken string — OPTIONALuuid string — OPTIONAL | `type`string—**OPTIONAL** | `value`string—**OPTIONAL** | `actionTimetoken`string—**OPTIONAL** | `messageTimetoken`string—**OPTIONAL** | `uuid`string—**OPTIONAL** |
| `type`string—**OPTIONAL** |
| `value`string—**OPTIONAL** |
| `actionTimetoken`string—**OPTIONAL** |
| `messageTimetoken`string—**OPTIONAL** |
| `uuid`string—**OPTIONAL** |
| `more`object—**OPTIONAL**url string — OPTIONALstart string — OPTIONALend string — OPTIONALlimit string — OPTIONAL | `url`string—**OPTIONAL** | `start`string—**OPTIONAL** | `end`string—**OPTIONAL** | `limit`string—**OPTIONAL** |
| `url`string—**OPTIONAL** |
| `start`string—**OPTIONAL** |
| `end`string—**OPTIONAL** |
| `limit`string—**OPTIONAL** |
| `400`The subscribe key is invalid.Schema — OPTIONALstatus integer — OPTIONALerror object — OPTIONALsource string — OPTIONALmessage string — OPTIONAL | Schema—**OPTIONAL** | `status`integer—**OPTIONAL** | `error`object—**OPTIONAL**source string — OPTIONALmessage string — OPTIONAL | `source`string—**OPTIONAL** | `message`string—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `error`object—**OPTIONAL**source string — OPTIONALmessage string — OPTIONAL | `source`string—**OPTIONAL** | `message`string—**OPTIONAL** |
| `source`string—**OPTIONAL** |
| `message`string—**OPTIONAL** |
| `403`The client isn't authorized to perform this operation.Schema — OPTIONALstatus integer — OPTIONALerror object — OPTIONALsource string — OPTIONALmessage string — OPTIONAL | Schema—**OPTIONAL** | `status`integer—**OPTIONAL** | `error`object—**OPTIONAL**source string — OPTIONALmessage string — OPTIONAL | `source`string—**OPTIONAL** | `message`string—**OPTIONAL** |
| Schema—**OPTIONAL** |
| `status`integer—**OPTIONAL** |
| `error`object—**OPTIONAL**source string — OPTIONALmessage string — OPTIONAL | `source`string—**OPTIONAL** | `message`string—**OPTIONAL** |
| `source`string—**OPTIONAL** |
| `message`string—**OPTIONAL** |

sub_key
*
Type:
string
Your app's subscribe key from
[Admin Portal](https://admin.pubnub.com)
.
channel
*
Type:
string
The channel ID to perform the operation on.
start
Type:
string
Action timetoken denoting the start of the range requested. Returned values will be less than
start
.
end
Type:
string
Action timetoken denoting the end of the range requested. Returned values will be greater than or equal to
end
.
limit
Type:
integer
Number of actions to return in response.
auth
Type:
string
String which is either the auth key (Access Manager legacy) or a valid token (
[Access Manager](https://www.pubnub.com/docs/security/access-control/overview.md)
) used to authorize the operation if access control is enabled.
signature
Type:
string
Signature used to verify that the request was signed with the secret key

associated with the subscribe key.

If Access Manager is enabled, either a valid authorization token or a signature are required.

Check
[Access Manager documentation](https://www.pubnub.com/docs/sdks/rest-api/access-manager-introduction.md)
for details on how to compute the signature.
timestamp
Type:
integer
Unix epoch timestamp used as a nonce for signature computation. Must

have no more than ± 60 seconds offset from NTP.

Required if the
signature
parameter is supplied.
status
Type:
integer
Example:
200
data
Type:
array
Array items:
items
Type:
object
more
Type:
object
status
Type:
integer
Example:
400
error
Type:
object
status
Type:
integer
Example:
403
error
Type:
object
